/*
 *      Copyright (C) 2009 Four J's Development Tools Europe, Ltd.
 *      http://www.fourjs.com
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef _ABSTRACT_TERMINAL_WIDGET_H_
#define _ABSTRACT_TERMINAL_WIDGET_H_

#include <QWidget>

class QMenu;
class AbstractTerminalWidget:public QWidget
{
    public:
    AbstractTerminalWidget(QWidget* p=0):QWidget(p) {}
    virtual ~AbstractTerminalWidget() {}
    virtual void init()=0;
    virtual void scroll(int lines)=0;
    virtual void setCursor(int x,int y,const QString& text,unsigned long attr)=0;
    virtual void insertText(int x,int y,const QString& ,unsigned long attr)=0;
    virtual void sendText(const QString& text) const=0;
    virtual void setSelectedText(const QString& text)=0;
    virtual void requestPaste()=0;
    virtual void contextMenu(QMenu* menu) const=0;
#ifndef Q_WS_WIN
    virtual int registerFd(int fd,int rwx)=0;
    virtual void releaseFd(int id)=0;
#endif
    virtual void timerChangeNotify(long ticks,long nextNow)=0;
    virtual void scrollTermTo(int lineNo)=0;
    virtual int colDiff(int width) const=0;
    virtual int lineDiff(int height) const=0;
    virtual void resize(int width,int height)=0;
    virtual void scale(int width,int height)=0;
    virtual void* realObject()=0;
};

#endif
