/*
 *      Copyright (C) 2009 Four J's Development Tools Europe, Ltd.
 *      http://www.fourjs.com
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#include "configDialog.h"
#include <QResizeEvent>
#include <QDebug>

ConfigDialog::ConfigDialog(const QString& title,Config* cfg,int midsession,int protcfginfo):QDialog(),_cfg(cfg),_midSession(midsession),_protCfgInfo(protcfginfo)
{
    setWindowTitle(title);
}

ConfigDialog::~ConfigDialog()
{
}

int
ConfigDialog::exec()
{
    _configWidget.fill(_cfg,this,_midSession,_protCfgInfo);
    setLayout(_configWidget.layout());
    return QDialog::exec();
}

void 
ConfigDialog::resizeEvent(QResizeEvent* e)
{
    e->accept();
    if(e->oldSize()==QSize(-1,-1))
    {
        setMaximumSize(e->size());
        setMinimumSize(e->size());
    }
}
