/*
 *      Copyright (C) 2009 Four J's Development Tools Europe, Ltd.
 *      http://www.fourjs.com
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef PUTTY_GRID_LAYOUT
#define PUTTY_GRID_LAYOUT

#include <QGridLayout>

class PuttyGridLayout:public QGridLayout
{
    Q_OBJECT
    public:
    PuttyGridLayout(int colCount,int* colStretch=0);
    void add(QObject* x,int colNo);

    private:
    void addLayout(QLayout* layout,int colNo);
    void addWidget(QWidget* widget,int colNo);
    int validateColNo(int colNo);
    void updateRowNo(int colNo);

    private:
    int _colCount;
    int _colNo;
    int _rowNo;
};

#endif
