/*
 *      Copyright (C) 2009 Four J's Development Tools Europe, Ltd.
 *      http://www.fourjs.com
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef _TERMINAL_CURSOR_H_
#define _TERMINAL_CURSOR_H_

#include <QObject>
#include <QRect>

class QPainter;
class QWidget;

namespace PTerminal
{
class Widget;
class Cursor:public QObject
{
    Q_OBJECT
    public:
    enum Shape {Block,Underline,Vertical,Empty};
    Cursor(Widget* parent);
    ~Cursor();
    int col() const;
    int line() const;
    void setText(const QString& text,unsigned long attr);
    void setShape(int shape);
    void draw(QPainter& p);

    protected:
    Widget* widget() const;

    private:
    Shape _shape;
    int _shapeWidth;
    QRect _rect;
    QString _text;
    unsigned long _attr;
};
}

#endif
