/*
 *      Copyright (C) 2010 Four J's Development Tools Europe, Ltd.
 *      http://www.fourjs.com
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef _TERMINAL_TEXT_H_
#define _TERMINAL_TEXT_H_

#include <QObject>
#include <QColor>
#include <QFont>
#include <QRect>
#include <QHash>
#include <QPolygon>

class QPainter;
namespace PTerminal
{
class Widget;
class Text:public QObject
{
    Q_OBJECT
    Q_ENUMS(LDC)
    public:
    enum LDC {begin=0x2500,
              lh=0x2500,//hh=0x2501,
              lv=0x2502,//lh=0x2503,
              ldlr=0x250c,//-0x250F
              ldll=0x2510,//-0x2513
              lulr=0x2514,//-0x2517
              lull=0x2518,//-0x251B
              lvlr=0x251C,//-0x2523
              lvll=0x2524,//-0x252B
              lhld=0x252C,//-0x2533
              lhlu=0x2534,//-0x253b
              lhlv=0x253C,//-0x254b
              end=0x254B};

    Text(Widget* p=0);
    void init();
    bool isLdc(const QChar& c) const;
    void draw(QPainter& p,const QRect& r,const QString& text,unsigned long attr);

    protected:
    Widget* widget() const;

    public:
    QHash<LDC,QPolygon> _ldcMap;
    QPoint _fontSize;
};
}

#endif
